//----------------------------------------------------------------------------------
//  mov.c
//  o{uh
//----------------------------------------------------------------------------------
#include <windows.h>
#include <mmintrin.h>
#include <xmmintrin.h>
#include <string.h>

#include "filter.h"
#include "mov.h"

//o
void detect_motion(PIXEL_YC *ref, PIXEL_YC *now, short *dst, int h, int max_w, int w, int th)
{
  int i,j,k;
  short ss;
  short s[5];
  float rp_th,f;
  short *dst0;
  th *= 8;
  rp_th = 4096.0f/(th * th);
  
  //rt[ƍƂ
  dst0 = dst + (h+1) * max_w;
  for(i=0; i<h; ++i){
    for(j=0; j<w; ++j){
      //e̐΍̍ől߂ĕۑ
      s[0] = (short)abs((now + j)->y  - (ref + j)->y );
      s[1] = (short)abs((now + j)->cb - (ref + j)->cb);
      s[2] = (short)abs((now + j)->cr - (ref + j)->cr);
      s[0] = s[0]>s[1] ? s[0] : s[1];
      s[0] = s[0]>s[2] ? s[0] : s[2];

      *(dst0 + j) = s[0];
    }
    now += max_w;
    ref += max_w;
    dst0 += max_w;
  }

  //ӃsNZl
  dst0 = dst + h * max_w;
  memset(dst0, 0, w * sizeof(short));
  memset(dst0 + (h+1)*max_w, 0, w * sizeof(short));
  dst0 += max_w;
  for(i=0; i<h; ++i){
    for(j=0; j<w; ++j){
      s[0] = *(dst0 + j);
      s[1] = j<w-1 ? *(dst0 + j + 1) : 0;
      s[2] = j>0   ? *(dst0 + j - 1) : 0;
      s[3] = *(dst0 + j + max_w);
      s[4] = *(dst0 + j - max_w);

      //\[gčől𓾂
      for(k=0; k<4; ++k){
        if(s[k]>s[k+1]){
          ss = s[k];
          s[k] = s[k+1];
          s[k+1] = ss;
        }
      }

      //2Ԗڂɑ傫Ȓl𓾂
      for(k=0; k<3; ++k){
        if(s[k]>s[k+1]){
          s[k+1] = s[k];
        }
      }

      //ς
      ss = (s[3] + s[4] + 1)/2;

      //臒l1.0ƂĐK
      f  = 0.5f;
      f += ss * ss * rp_th;
      if(f > 4096.0f){
        ss = 4096;
      }else{
        ss = (short)f;
      }

      *(dst + j)  = ss;
    }
    dst  += max_w;
    dst0 += max_w;
  }
}



//o SSE
void detect_motion_sse(PIXEL_YC *ref, PIXEL_YC *now, short *dst, int h, int max_w, int w, int th)
{
  int i,j;
  int i0,i1;
  short *dst0, *dst1;
  __m64 m0,m1,m2,n0,n1,n2;
  __m64 s0,s1,s2,s3,s4,t0;
  __m128 xm0,xr0,xc0;
  __declspec(align(16)) static const float c[4] = {4096.0f, 4096.0f, 4096.0f, 4096.0f};
  __declspec(align(8)) static const unsigned short u[4][4] =
    { { 65535U, 65535U, 65535U, 65535U },
      { 65535U,     0U,     0U,     0U },
      { 65535U, 65535U,     0U,     0U },
      { 65535U, 65535U, 65535U,     0U }
    };
  
  //臒lg̑O
  th *= 8;
  xc0 = _mm_load_ps(c);
  xr0 = xm0 = xc0;
  xm0 = _mm_cvtsi32_ss(xm0, th);     //xm0 (4k,4k,4k,th)
  xm0 = _mm_shuffle_ps(xm0, xm0, 0); //xm0 (th,th,th,th)
  xm0 = _mm_mul_ps(xm0, xm0);        //xm0 (th2,th2,th2,th2):th2 = th*th
  xm0 = _mm_rcp_ps(xm0);             //xm0 (1/th2,1/th2h,1/th2,1/th2)
  xr0 = _mm_mul_ps(xr0, xm0);        //xr0 (4k/th2,4k/th2h,4k/th2,4k/th2)

  //E[̏p
  t0 = *(__m64*)u[w&3];
  m0 = _mm_setzero_si64();
  
  //rt[ƍƂ
  dst0 = dst + (h+1) * max_w;
  for(i=0; i<h; ++i){
    //[̏
    *(dst0 - 1) = 0;
    
    for(j=0; j<w; j+=4){
      //e̐΍̍ől߂ĕۑ
      m0 = _mm_subs_pi16(*((__m64*)(now + j)  ), *((__m64*)(ref + j)  ));
      m1 = _mm_subs_pi16(*((__m64*)(now + j)+1), *((__m64*)(ref + j)+1));
      m2 = _mm_subs_pi16(*((__m64*)(now + j)+2), *((__m64*)(ref + j)+2));
      //̐Βl
      n0 = _mm_setzero_si64();
      n1 = _mm_setzero_si64();
      n2 = _mm_setzero_si64();
      n0 = _mm_subs_pi16(n0, m0);
      n1 = _mm_subs_pi16(n1, m1);
      n2 = _mm_subs_pi16(n2, m2);
      m0 = _mm_max_pi16(m0, n0);
      m1 = _mm_max_pi16(m1, n1);
      m2 = _mm_max_pi16(m2, n2);
      
      //m0 ( Y1, Cr0, Cb0,  Y0)
      //m1 (Cb2,  Y2, Cr1, Cb1)
      //m2 (Cr3, Cb3,  Y3, Cr2)

      //vf̓ւ
      i0 = _mm_extract_pi16(m0, 1);
      i1 = _mm_extract_pi16(m1, 2);
      m0 = _mm_insert_pi16(m0, i1, 1);
      m1 = _mm_insert_pi16(m1, i0, 2);

      i0 = _mm_extract_pi16(m1, 1);
      i1 = _mm_extract_pi16(m2, 2);
      m1 = _mm_insert_pi16(m1, i1, 1);
      m2 = _mm_insert_pi16(m2, i0, 2);

      i0 = _mm_extract_pi16(m2, 1);
      i1 = _mm_extract_pi16(m0, 2);
      m2 = _mm_insert_pi16(m2, i1, 1);
      m0 = _mm_insert_pi16(m0, i0, 2);

      //m0 ( Y1,  Y3,  Y2,  Y0)
      //m1 (Cb2, Cb0, Cb3, Cb1)
      //m2 (Cr3, Cr1, Cr0, Cr2)

      m0 = _mm_shuffle_pi16(m0, 0x9C); // 2,1,3,0 10011100
      m1 = _mm_shuffle_pi16(m1, 0x72); // 1,3,0,2 01110010
      m2 = _mm_shuffle_pi16(m2, 0xC9); // 3,0,2,1 11001001

      //m0 ( Y3,  Y2,  Y1,  Y0)
      //m1 (Cb3, Cb2, Cb1, Cb0)
      //m2 (Cr3, Cr2, Cr1, Cr0)
      
      //őlo
      m1 = _mm_max_pi16(m1, m2);
      m0 = _mm_max_pi16(m0, m1);

      *(__m64*)(dst0 + j) = m0;
    }
    //E[̏
    *(__m64*)(dst0 + j - 4) = _mm_and_si64(m0, t0);
    *(dst0 + j) = 0;
    
    now += max_w;
    ref += max_w;
    dst0 += max_w;
    
  }
  
  //ӃsNZl
  dst0 = dst  + h * max_w;
  dst1 = dst0 + (h + 1) * max_w;
  t0 = _mm_setzero_si64();
  for(j=0; j<w; j+=4){
    *(__m64*)(dst0 + j) = t0;
    *(__m64*)(dst1 + j) = t0;
  }
  dst0 += max_w;
  for(i=0; i<h; ++i){
    for(j=0; j<w; j+=4){
      s0 = *(__m64*)(dst0 + j);
      s1 = *(__m64*)(dst0 + j + 1); //ACgĂȂ
      s2 = *(__m64*)(dst0 + j - 1); //ACgĂȂ
      s3 = *(__m64*)(dst0 + j + max_w);
      s4 = *(__m64*)(dst0 + j - max_w);
      
      //\[gčől𓾂
      t0 = _mm_max_pi16(s4, s3);
      s4 = _mm_min_pi16(s4, s3);
      s3 = t0;
      t0 = _mm_max_pi16(s3, s2);
      s3 = _mm_min_pi16(s3, s2);
      s2 = t0;
      t0 = _mm_max_pi16(s2, s1);
      s2 = _mm_min_pi16(s2, s1);
      s1 = t0;
      t0 = _mm_max_pi16(s1, s0);
      s1 = _mm_min_pi16(s1, s0);
      s0 = t0;

      //2Ԗڂɑ傫Ȓl𓾂
      s3 = _mm_max_pi16(s3, s4);
      s2 = _mm_max_pi16(s2, s3);
      s1 = _mm_max_pi16(s1, s2);

      //ς
      s0 = _mm_avg_pu16(s0, s1);

      //Pxɕϊ
      xm0 = _mm_cvtpu16_ps(s0);

      //臒l傫ꍇ4096ɂ
      xm0 = _mm_mul_ps(xm0, xm0);
      xm0 = _mm_mul_ps(xm0, xr0);
      xm0 = _mm_min_ps(xm0, xc0);
      
      *(__m64*)(dst + j) = _mm_cvtps_pi16(xm0);
    }
    dst  += max_w;
    dst0 += max_w;
  }
  
}

//2̓}XN̂傫ȂقI
short* select_max(short *p0, short *p1, int h, int max_w, int w)
{
  int i,j;
  short *p2 = p0 + h * max_w;
    
  for(i=0; i<h; ++i){
    for(j=0; j<w; ++j){
      *(p2 + j) = *(p0 + j) > *(p1 + j) ? *(p0 + j) : *(p1 + j);
    }
    p2 += max_w;
    p1 += max_w;
    p0 += max_w;
  }

  return p0;
}

//2̓}XN̂ȂقI
short* select_min(short *p0, short *p1, int h, int max_w, int w)
{
  int i,j;
  short *p2 = p0 + h * max_w;
    
  for(i=0; i<h; ++i){
    for(j=0; j<w; ++j){
      *(p2 + j) = *(p0 + j) < *(p1 + j) ? *(p0 + j) : *(p1 + j);
    }
    p2 += max_w;
    p1 += max_w;
    p0 += max_w;
  }

  return p0;
}

//2̓}XN̂傫ȂقI SSE
short* select_max_sse(short *p0, short *p1, int h, int max_w, int w)
{
  int i,j;
  short *p2 = p0 + h * max_w;
    
  for(i=0; i<h; ++i){
    for(j=0; j<w; j+=4){
      *(__m64*)(p2 + j) = _mm_max_pi16(*(__m64*)(p0 + j), *(__m64*)(p1 + j));
    }
    p2 += max_w;
    p1 += max_w;
    p0 += max_w;
  }

  return p0;
}

//2̓}XN̂ȂقI SSE
short* select_min_sse(short *p0, short *p1, int h, int max_w, int w)
{
  int i,j;
  short *p2 = p0 + h * max_w;
    
  for(i=0; i<h; ++i){
    for(j=0; j<w; j+=4){
      *(__m64*)(p2 + j) = _mm_min_pi16(*(__m64*)(p0 + j), *(__m64*)(p1 + j));
    }
    p2 += max_w;
    p1 += max_w;
    p0 += max_w;
  }

  return p0;
}

//̗ʂɂăuh
void brend_image(PIXEL_YC *dst, PIXEL_YC *src, short *mot, int h, int max_w, int w)
{
  int i,j;
  int y,cr,cb,c0,c1;
  
  for(i=0; i<h; ++i){
    for(j=0; j<w; ++j){
      c0 = *(mot + j);
      c1 = 4096 - c0;
      y  = c0 * (dst + j)->y  + c1 * (src + j)->y;
      cb = c0 * (dst + j)->cb + c1 * (src + j)->cb;
      cr = c0 * (dst + j)->cr + c1 * (src + j)->cr;
      
      (dst + j)->y = (short)(y >> 12);
      (dst + j)->cb = (short)(cb >> 12);
      (dst + j)->cr = (short)(cr >> 12);
    }
    dst += max_w;
    src += max_w;
    mot += max_w;
  }
}

//̗ʂɂăuh MMX
void brend_image_mmx(PIXEL_YC *dst, PIXEL_YC *src, short *mot, int h, int max_w, int w)
{
  int i,j;
  __m64 m0,m1,d0,s0,c0,c1,c2,c3;
  __declspec(align(8)) static const short c[4] = {4096, 4096, 4096, 4096};

  c3 = *(__m64*)c;

  for(i=0; i<h; ++i){
    for(j=0; j<w; j+=4){
      c0 = *(__m64*)(mot + j); //c0 (c3,c2,c1,c0)
      c1 = _mm_subs_pu16(c3, c0); //c1 (4k-c3,4k-c2,4k-c1,4k-c0)
      
      c2 = _mm_unpackhi_pi16(c1, c0); //c2 (c3,4k-c3,c2,4k-c2)
      c1 = _mm_unpacklo_pi16(c1, c0); //c1 (c1,4k-c1,c0,4k-c0)

      //0
      d0 = *(__m64*)(dst + j); //d0 (Yd1, Crd0, Cbd0, Yd0)
      s0 = *(__m64*)(src + j); //s0 (Ys1, Crs0, Cbs0, Ys0)

      m0 = _mm_unpackhi_pi16(s0, d0); //m0 (Yd1,   Ys1, Crd0, Crs0)
      m1 = _mm_unpacklo_pi16(s0, d0); //m1 (Cbd0, Cbs0,  Yd0,  Ys0)

      c0 = _mm_unpacklo_pi32(c1, c1); //c0 (c0,4k-c0,c0,4k-c0)

      m0 = _mm_madd_pi16(m0, c1); //m0 (Yd1*c1 + Ys1*(4k-c1), Crd0*c0 + Crs1*(4k-c0))
      m1 = _mm_madd_pi16(m1, c0); //m1 (Cbd0*c0 + Cbs0*(4k-c0), Yd0*c0 + Ys0*(4k-c0))

      m0 = _mm_srai_pi32(m0, 12);
      m1 = _mm_srai_pi32(m1, 12);
      
      *(__m64*)(dst + j) = _mm_packs_pi32(m1, m0);

      //1
      d0 = *((__m64*)(dst + j) + 1); //d0 (Cbd2, Yd2, Crd1, Cbd1)
      s0 = *((__m64*)(src + j) + 1); //s0 (Cbs2, Ys2, Crs1, Cbs1)

      m0 = _mm_unpackhi_pi16(s0, d0); //m0 (Cbd2, Cbs2, Yd2, Ys2)
      m1 = _mm_unpacklo_pi16(s0, d0); //m1 (Crd1, Crs1, Cbd1, Cbs1)

      c0 = _mm_unpacklo_pi32(c2, c2); //c0 (c2,4k-c2,c2,4k-c2)
      c1 = _mm_unpackhi_pi32(c1, c1); //c1 (c1,4k-c1,c1,4k-c1)

      m0 = _mm_madd_pi16(m0, c0); //m0 (Cbd2*c2 + Cbs2*(4k-c2), Yd2*c2 + Ys2*(4k-c2))
      m1 = _mm_madd_pi16(m1, c1); //m1 (Crd1*c1 + Crs1*(4k-c1), Cbd1*c1 + Cbs1*(4k-c1))
      
      m0 = _mm_srai_pi32(m0, 12);
      m1 = _mm_srai_pi32(m1, 12);
      
      *((__m64*)(dst + j) + 1) = _mm_packs_pi32(m1, m0);

      //2
      d0 = *((__m64*)(dst + j) + 2); //d0 (Crd3, Cbd3, Yd3, Crd2)
      s0 = *((__m64*)(src + j) + 2); //s0 (Crs3, Cbs3, Ys3, Crs2)

      m0 = _mm_unpackhi_pi16(s0, d0); //m0 (Crd3, Crs3, Cbd3, Cbs3)
      m1 = _mm_unpacklo_pi16(s0, d0); //m1 (Yd3, Ys3, Crd2, Crs2)

      c1 = _mm_unpackhi_pi32(c2, c2); //c1 (c3,4k-c3,c3,4k-c3)

      m0 = _mm_madd_pi16(m0, c1); //m0 (Crd3*c3 + Crs3*(4k-c3), Cbd3*c3 + Cbs3*(4k-c3))
      m1 = _mm_madd_pi16(m1, c2); //m1 (Yd3*c3 + Ys3*(4k-c3), Crd2*c2 + Crs2*(4k-c2))

      m0 = _mm_srai_pi32(m0, 12);
      m1 = _mm_srai_pi32(m1, 12);

      *((__m64*)(dst + j) + 2) = _mm_packs_pi32(m1, m0);
    }
    dst += max_w;
    src += max_w;
    mot += max_w;
  }

  _mm_empty();
}

//\
void disp_motion(PIXEL_YC *dst, short *mot, int h, int max_w, int w)
{
  int i,j;

  for(i=0; i<h; ++i){
    for(j=0; j<w; ++j){
      (dst + j)->cb = (*(mot + j) * -2231) >> 13;
      (dst + j)->cr = (*(mot + j) *  3435) >> 13;
    }
    dst += max_w;
    mot += max_w;
  }
}


